#include "parsing.h"

char *resize1(char *txt, int l1, int l2){
  // augmente la taille du tableau txt de l1 vers l2
  char *cpy = malloc(l2 * sizeof(char));
  for (int i = 0; i < l1; i = i + 1){
    cpy[i] = txt[i];
  }
  free(txt);
  return cpy;
}

void resize2(char **txt, int l1, int l2){
  // augmente la taille du tableau txt de l1 vers l2
  char *cpy = malloc(l2 * sizeof(char));
  for (int i = 0; i < l1; i = i + 1){
    cpy[i] = (*txt)[i];
  }
  free(*txt);
  *txt = cpy;
}

char *read_file1(char filename[]){
  int len = 0;
  char buf;
  FILE * f = fopen(filename, "r");
  while (fscanf(f,"%c", &buf) != EOF){
    len = len + 1;
  }
  fclose(f);
  char *txt = malloc((len+1) * sizeof(char));
  f = fopen(filename, "r");
  for (int i = 0; i < len; i = i + 1){
    fscanf(f,"%c", &txt[i]);
    
  }
  fclose(f);
  txt[len] = '\0';
  return txt;
}

char *read_file2(char filename[]){
  int cpt = 0; int max = 0;
  char buf;
  char *txt = malloc((max+1) * sizeof(char));
  FILE * f = fopen(filename, "r");
  while (fscanf(f,"%c", &buf) != EOF){
    if (cpt >= max){
      max = max + 1;
      txt = resize1(txt, cpt, max + 1);
    }
    txt[cpt] = buf;
    cpt = cpt + 1;
  }
  fclose(f);
  txt[cpt] = '\0';
  return txt;
}

char *read_file(char filename[]){
  int cpt = 0; int max = 1;
  char buf;
  char *txt = malloc((max+1) * sizeof(char));
  FILE * f = fopen(filename, "r");
  while (fscanf(f,"%c", &buf) != EOF){
    if (cpt >= max){
      max = 2 * max;
      txt = resize1(txt, cpt, max + 1);
    }
    txt[cpt] = buf;
    cpt = cpt + 1;
  }
  fclose(f);
  txt[cpt] = '\0';
  return txt;
}


